<?php

namespace LakeDrops\DorgFlow;

use LakeDrops\Component\Composer\BaseCommand;
use Symfony\Component\Console\Input\InputArgument;
use Symfony\Component\Console\Input\InputInterface;
use Symfony\Component\Console\Output\OutputInterface;

/**
 * Composer Issue Fork Command for DorgFlow.
 *
 * @package LakeDrops\DorgFlow
 */
class IssueForkCommand extends BaseCommand {

  /**
   * {@inheritdoc}
   */
  protected function configure(): void {
    parent::configure();
    $this
      ->setName('lakedrops:issuefork')
      ->addArgument('Project', InputArgument::REQUIRED, 'Name of the project, e.g. core')
      ->addArgument('Issue', InputArgument::REQUIRED, 'Number fo the issue')
      ->setDescription('Load an issue fork for a specific project from drupal.org.');
  }

  /**
   * {@inheritdoc}
   */
  public function getHandlerClass(): string {
    return Handler::class;
  }

  /**
   * {@inheritdoc}
   */
  protected function execute(InputInterface $input, OutputInterface $output): int {
    parent::execute($input, $output);
    /** @var Handler $handler */
    $handler = $this->handler;
    $handler->loadIssueFork($input->getArgument('Project'), $input->getArgument('Issue'));
    return 0;
  }

}
