<?php

namespace LakeDrops\DorgFlow;

use Composer\Plugin\Capability\CommandProvider as ComposerCommandProvider;
use Composer\Script\Event;
use Composer\Script\ScriptEvents;
use LakeDrops\Component\Composer\BasePlugin;

/**
 * Composer plugin for preparing Drupal project for development with dorgflow.
 */
class Plugin extends BasePlugin {

  /**
   * {@inheritdoc}
   */
  public function getHandlerClass(): string {
    return Handler::class;
  }

  /**
   * {@inheritdoc}
   */
  public function getCapabilities(): array {
    return [
      ComposerCommandProvider::class => CommandProvider::class,
    ];
  }

  /**
   * {@inheritdoc}
   */
  public static function getSubscribedEvents(): array {
    return [
      ScriptEvents::POST_INSTALL_CMD => 'prepareDevProjects',
      ScriptEvents::POST_UPDATE_CMD => 'prepareDevProjects',
    ];
  }

  /**
   * Post install/update event callback.
   *
   * @param \Composer\Script\Event $event
   *   The event that triggered the call of this function.
   */
  public function prepareDevProjects(Event $event): void {
    /** @var \LakeDrops\DorgFlow\Handler $handler */
    $handler = $this->handler;
    $handler->setEvent($event);
    $handler->prepareDevProjects();
  }

}
